/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/editnonstd.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:36:16 $
 * $Log: editnonstd.c,v $
 *	Revision 1.2  1993/10/24  18:36:16  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:41  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "search.h"
#include "edit.h"
#include "nonstd.h"

static int funcNonStd(int);

int NonStdEdit()
{
  int length, i;

  length = NonStdReadID();
  if (length < 256)
    length = 256;
  ptr = Malloc(length);
  for (i = 0; i < length; ++i)
    ptr[i] = 0;
  edit((int)ptr, length, 0, funcNonStd);
  free(ptr);
  return 0;
}

static int funcNonStd(int keyNo)
{
  int i;

  switch (keyNo)
    {
    case FUNC_PRE:
      B_LOCATE(22, 3);
      B_PRINT("\33[36m[[[ \33[35m@@ \33[36m]]]");
      NonStdPrint();
      FNCKEYST(1, MesFKeyDriveC);
      FNCKEYST(2, MesFKeyReadC);
      FNCKEYST(3, MesFKeyWriteC);
      FNCKEYST(6, MesFKeyNxtTrckC);
      FNCKEYST(7, MesFKeyLstTrckC);
      FNCKEYST(9, MesFKeyNxtSctrC);
      FNCKEYST(10, MesFKeyLstSctrC);
      FNCKEYST(12, MesFKeyLoadC);
      FNCKEYST(13, MesFKeySaveC);
      FNCKEYST(16, MesFKeyHdTrckC);
      FNCKEYST(17, MesFKeyTrckNoC);
      FNCKEYST(19, MesFKeyHdSctrC);
      FNCKEYST(20, MesFKeySctrNoC);
      sizeEdit = NonStdRead(ptr);
      if (sizeEdit < 256)
	sizeEdit = 256;
      endEdit = topEdit + sizeEdit - 256;
      NonStdPrint();
      return 0;
    case 1:
      if (checkHenkouEdit(HenDRIVE))
	return FUNC_ERROR;
      NonStdDriveIn();
      goto newtrack;
    case 2:
      if (checkHenkouEdit(HenREAD))
	return FUNC_ERROR;
      break;
    case 3:
      B_LOCATE(22, 29);
      B_PRINT(MesWriteOKQ);
      keyNo = GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (keyNo == 0x16)
	{
	  NonStdWrite(ptr);
	  henkouEdit = 0;
	}
      return FUNC_NORMAL;
    case 6:
      if (checkHenkouEdit(HenTRACK))
	return FUNC_ERROR;
      NonStdTrackInc();
      goto newtrack;
    case 7:
      if (checkHenkouEdit(HenTRACK))
	return FUNC_ERROR;
      NonStdTrackDec();
      goto newtrack;
    case 16:
      if (checkHenkouEdit(HenTRACK))
	return FUNC_ERROR;
      NonStdTrackHead();
      goto newtrack;
    case 17:
      if (checkHenkouEdit(HenTRACK))
	return FUNC_ERROR;
      NonStdTrackIn();
    newtrack:
      free(ptr);
      keyNo = NonStdReadID();
      if (keyNo < 256)
	keyNo = 256;
      ptr = Malloc(keyNo);
      for (i = 0; i < keyNo; ++i)
	ptr[i] = 0;
      break;
    case 9:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      NonStdInc();
      break;
    case 10:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      NonStdDec();
      break;
    case 12:
      funcLOAD();
      return FUNC_NORMAL;
    case 13:
      funcSAVE();
      return FUNC_NORMAL;
    case 19:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      NonStdHead();
      break;
    case 20:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      NonStdIn();
      break;
    case 29:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      if (NonStdInc())
	{
	  if (NonStdTrackInc())
	    {
	      NonStdTrackDec();
	      return FUNC_ERROR;
	    }
	  goto newtrack;
	}
      break;
    case 30:
      if (checkHenkouEdit(HenSECTOR))
	return FUNC_ERROR;
      if (NonStdDec())
	{
	  if (NonStdTrackDec())
	    {
	      NonStdTrackInc();
	      return FUNC_ERROR;
	    }
	  goto newtrack;
	}
      break;
    default:
      return FUNC_NORMAL;
    }
  sizeEdit = NonStdRead(ptr);
  if (sizeEdit < 256)
    sizeEdit = 256;
  endEdit = topEdit + sizeEdit - 256;
  NonStdPrint();
  Dump(adrEdit, topEdit - offset);
  return FUNC_NORMAL;
}
