/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/editsub.c,v $
 * $Author: kawamoto $
 * $Revision: 1.4 $
 * $Date: 1995/05/08 01:04:15 $
 * $Log: editsub.c,v $
 *	Revision 1.4  1995/05/08  01:04:15  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.3  1994/04/23  11:36:23  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:36:32  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:41:56  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "search.h"
#include "edit.h"

#define LOCATE_BASE 11

char henkouEdit;

int checkHenkouEdit(int type)
{
  int i = 0;
  char *p = NULL;

  if (henkouEdit == 0)
    return 0;
  switch (type)
    {
    case HenEND:
      i = LOCATE_BASE+7;
      break;
    case HenDRIVE:
      i = LOCATE_BASE+2;
      break;
    case HenSOUCHI:
      i = LOCATE_BASE+2;
      break;
    case HenTRACK:
      i = LOCATE_BASE+0;
      break;
    case HenSECTOR:
      i = LOCATE_BASE+0;
      break;
    case HenREAD:
      i = LOCATE_BASE+6;
      break;
    case HenLOAD:
      i = LOCATE_BASE+6;
      break;
    case HenADDR:
      i = LOCATE_BASE+2;
      break;
    }
  B_LOCATE(i, 29);
  B_PRINT("\33[36mobt@eL܂B{");
  switch (type)
    {
    case HenEND:
      p = "I";
      break;
    case HenDRIVE:
      p = "hCuύX";
      break;
    case HenSOUCHI:
      p = "uԍύX";
      break;
    case HenTRACK:
      p = "gbNmύX";
      break;
    case HenSECTOR:
      p = "ZN^[mύX";
      break;
    case HenREAD:
      p = "ǂݍ";
      break;
    case HenLOAD:
      p = "[h";
      break;
    case HenADDR:
      p = "AhXύX";
      break;
    }
  B_PRINT(p);
  B_PRINT("܂iy/njH ");
  i = GetKey();
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (i == 0x16)
    {
      henkouEdit = 0;
      return 0;
    }
  else
    return 1;
}

static char saveLoad[80] = {0};

void funcLOAD()
{
  int fp, buf, siz, of;

  if (checkHenkouEdit(HenLOAD))
    return;
loop:
  B_LOCATE(23, 29);
  B_PRINT("\33[37m[ht@C H ");
  of = GetName(saveLoad, 40, 0);
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (of == ERROR)
    return;
  if ((fp = OPEN(saveLoad, 2)) < 0)
    {
      B_LOCATE(37, 29);
      B_PRINT(MesIlleName);
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      return;
    }
  buf = topEdit;
  siz = SEEK(fp, 0, 2);
  if (siz < sizeEdit)
    {
      B_LOCATE(33, 29);
      B_PRINT("\33[36mt@CTCY܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      of = sizeEdit;
      while (of > sizeEdit - siz)
	{
	  B_LOCATE(30, 29);
	  B_PRINT("\33[37mobt@ǂݍ݃ItZbg H $        ");
	  B_LOCATE(63, 29);
	  of = GetNum(16, 8, 0);
	}
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (of == ERROR)
	{
	  CLOSE(fp);
	  goto loop;
	}
      SEEK(fp, 0, 0);
      buf += of;
    }
  else if (siz > sizeEdit)
    {
      B_LOCATE(33, 29);
      B_PRINT("\33[36mt@CTCY傫܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      of = siz;
      while (of > siz - sizeEdit)
	{
	  B_LOCATE(30, 29);
	  B_PRINT("\33[37mt@CǂݏoItZbg H $        ");
	  B_LOCATE(63, 29);
	  of = GetNum(16, 8, 0);
	}
      B_LOCATE(0, 29);
      B_ERA_AL();
      if (of == ERROR)
	{
	  CLOSE(fp);
	  goto loop;
	}
      siz = sizeEdit;
      SEEK(fp, of, 0);
    }
  else
    SEEK(fp, 0, 0);
  READ(fp, (uchar *)buf, siz);
  CLOSE(fp);
  Dump(adrEdit, base);
}

void funcSAVE()
{
  if (FileSave(saveLoad, (schar *)topEdit, sizeEdit) > 0)
    henkouEdit = 0;
}

int dRead(uchar *ptr)
{
  int i;

  B_LOCATE(61, 5);
  B_COLOR(7);
  B_PUTC('$');
  for (i = 28; i >= 0; i -= 4)
    PutHex(sector >> i);
  B_CUROFF();
  return diskred(0, ptr, CurDrive, sector, 1);
}

int dClusterRead(uchar *ptr)
{
  int i;

  B_LOCATE(61, 5);
  B_COLOR(7);
  B_PUTC('$');
  for (i = 12; i >= 0; i -= 4)
    PutHex(cluster >> i);
  B_CUROFF();
  return diskred(0, ptr, CurDrive, FATnoToSector(cluster), DPBbuf.sec + 1);
}

char logicType = 0;

void logicTypeDisp()
{
  switch (logicType)
    {
    case 0:/* replace */
      FNCKEYST(Provisional_adjusts.function ? 14 : 4, "*replace");
      break;
    case 1:/* and */
      FNCKEYST(Provisional_adjusts.function ? 14 : 4, "*  and");
      break;
    case 2:/* or */
      FNCKEYST(Provisional_adjusts.function ? 14 : 4, "*  or");
      break;
    case 3:/* xor */
      FNCKEYST(Provisional_adjusts.function ? 14 : 4, "*  xor");
      break;
    }
}

void editPre()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Window(11, 8, 74, 16);
  YLine(19, 8, 16);
  YLine(67, 8, 16);
  B_LOCATE(11, 6);
  B_COLOR(3);
  B_PRINT(MesAddress);
  B_LOCATE(8, 25);
  B_PRINT(MesCursScrl);
  B_PRINT(MesCursLURD);
  B_PRINT(MesHomeReturn);
  B_LOCATE(10, 26);
  B_PRINT(MesTenKey);
  B_LOCATE(32, 27);
  B_PRINT(MesRetESC);
  B_COLOR(3);
  B_CUROFF();
}

void editPost()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Clear23();
  NulFuncKey();
}

/* search functions */
/*    30 Sep. 1990  */

int is_forward;

static bool next_buffer_read(void);
static bool prev_buffer_read(void);
static srchbuf *search_buffer = (srchbuf *)NULL;

static int (*key_func)(int) = NULL;
static char inputbuf[64] = "";
static char target[64] = "";
static bool aborting;

static bool next_buffer_read()
{
  int i;

  while ((i = NonWaitKey()) != 0)
    if (i == 1)
      {
	aborting = true;
	return false;
      }
  return ((*key_func)(29) == FUNC_NORMAL);
}

static bool prev_buffer_read()
{
  int i;

  while ((i = NonWaitKey()) != 0)
    if (i == 1)
      {
	aborting = true;
	return false;
      }
  return ((*key_func)(30) == FUNC_NORMAL);
}

void searchInit(int (*func)(int))
{
  int i, j, b;
  char buf[64];

string_input:
  strcpy(buf, inputbuf);
  B_LOCATE(6, 29);
  B_PRINT("\33[37m ([hex] / s[string]) H ");
  i = GetString(buf, 48);
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (i == ERROR)
    return;
  if ((buf[0] != 's') && (buf[0] != 'S'))
    {
      if (buf[0] == '\0')
	goto string_input;
      for (i = 0; buf[i]; ++i)
	{
	  if (buf[i] < '0')
	    goto string_input;
	  if ('9' < buf[i] && buf[i] < 'A')
	    goto string_input;
	  if ('F' < buf[i] && buf[i] < 'a')
	    goto string_input;
	  if ('f' < buf[i])
	    goto string_input;
	}
      if (i % 2)
	goto string_input;
    }
  else if (buf[1] == '\0')
    goto string_input;
  B_LOCATE(40, 29);
  B_PRINT("\33[37mif/bjH ");
  i = GetASC();
  i = toupper(i);
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (i != 'F' && i != 'B')
    goto string_input;
  aborting = false;
  key_func = func;
  strcpy(inputbuf, buf);
  if (search_buffer)
    {
      free(search_buffer->sk_top);
      free(search_buffer);
    }
  is_forward = (i == 'F');
  if ((buf[0] != 's') && (buf[0] != 'S'))
    {
      i = 0;
      j = 0;
      while ((b = buf[j++]) != 0)
	{
	  target[i] = (b <= '9') ? (b - '0') :
		      ((b <= 'F') ? (b - 'A' + 10) : (b - 'a' + 10));
	  target[i] <<= 4;
	  b = buf[j++];
	  target[i++] |= (b <= '9') ? (b - '0') :
			 ((b <= 'F') ? (b - 'A' + 10) : (b - 'a' + 10));
	}
    }
  else
    {
      strcpy(target, buf + 1);
      i = strlen(target);
    }
  search_buffer = (srchbuf *)Malloc(sizeof(srchbuf));
  search_buffer->tar_size = i;
  search_buffer->tar_top = (uchar *)target;
  search_buffer->tar_end = (uchar *)target + i - 1;
  search_buffer->buf_top = (uchar *)topEdit;
  search_buffer->buf_end = (uchar *)topEdit + sizeEdit - 1;
  search_buffer->sk_top = (skip *)Malloc(sizeof(skip) * i);
  search_buffer->sk_end = search_buffer->sk_top + i - 1;
  if (is_forward)
    search_init(search_buffer, next_buffer_read);
  else
    rearch_init(search_buffer, prev_buffer_read);
}

static inline int Search(srchbuf *bptr)
{
  int stack = 0, ret;

  if (key_func == funcMem)
    stack = SUPER(0);
  ret = search(bptr);
  if (key_func == funcMem)
    SUPER(stack);
  return ret;
}

static inline int Rearch(srchbuf *bptr)
{
  int stack = 0, ret;

  if (key_func == funcMem)
    stack = SUPER(0);
  ret = rearch(bptr);
  if (key_func == funcMem)
    SUPER(stack);
  return ret;
}

int searchNext(int pos)
{
  int p = 0, t = 0;

  if (!search_buffer)
    return -1;
  pos += adrEdit - topEdit;
  if (key_func == funcMem)
    memSearchInit((uchar *)topEdit + pos, search_buffer, is_forward);
  switch (is_forward)
    {
    case true:
      search_buffer->buf_cur = (uchar *)topEdit + search_buffer->tar_size + pos - 1;
      if (Search(search_buffer) == false)
	{
	  adrEdit = endEdit;
	  p = 255;
	  break;
	}
      p = search_buffer->buf_cur - (uchar *)topEdit - search_buffer->tar_size + 1;
      if (p < 0)
	{
	  prev_buffer_read();
	  search_buffer->tar_cur = search_buffer->tar_top;
	  p += sizeEdit;
	}
      t = p & 0xfffffff0;
      t -= 0x80;
      adrEdit = topEdit + t;
      if (adrEdit < topEdit)
	adrEdit = topEdit;
      if (adrEdit > endEdit)
	adrEdit = endEdit;
      t = adrEdit - topEdit;
      while (NonWaitIOCS())
	;
      Dump(adrEdit, base);
      return p - t;
    case false:
      search_buffer->buf_cur = (uchar *)topEdit - search_buffer->tar_size + pos + 1;
      if (Rearch(search_buffer) == false)
	{
	  adrEdit = topEdit;
	  p = 0;
	  break;
	}
      p = search_buffer->buf_cur - (uchar *)topEdit + search_buffer->tar_size - 1;
      if (p >= sizeEdit)
	{
	  next_buffer_read();
	  search_buffer->tar_cur = search_buffer->tar_end;
	  p -= sizeEdit;
	}
      t = p & 0xfffffff0;
      t -= 0x70;
      adrEdit = topEdit + t;
      if (adrEdit < topEdit)
	adrEdit = topEdit;
      if (adrEdit > endEdit)
	adrEdit = endEdit;
      t = adrEdit - topEdit;
      while (NonWaitIOCS())
	;
      Dump(adrEdit, base);
      return p - t;
    }
  while (NonWaitIOCS())
    ;
  B_LOCATE(aborting ? 41 : 40, 29);
  B_PRINT(aborting ? "\33[36mf܂B" : "\33[36m܂B");
  WaitForAMoment(2);
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  Dump(adrEdit, base);
  return p;
}
