/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/funccoord.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:37:12 $
 * $Log: funccoord.c,v $
 *	Revision 1.2  1993/10/24  18:37:12  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:42:33  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "coord.h"
#include "dir.h"

void LoadFunctionCoordination(const char *buffer)
{
  if (strncmp(buffer, "CASE_SORT", 9) == 0)
    {
      for (buffer += 9; *buffer == ' ' || *buffer == '='; ++buffer)
	;
      distinct = ! (*buffer == 'F');
      return;
    }
  if (strncmp(buffer, "NUMBER_SORT", 11) == 0)
    {
      for (buffer += 11; *buffer == ' ' || *buffer == '='; ++buffer)
	;
      number = (*buffer == 'T');
      return;
   }
  if (strncmp(buffer, "SORT_TARGET", 11) == 0)
    {
      for (buffer += 11; *buffer == ' ' || *buffer == '='; ++buffer)
	;
      switch (*buffer)
	{
	case 'N':
	  target = 0;
	  break;
	case 'E':
	  target = 1;
	  break;
	case 'W':
	default:
	  target = 2;
	  break;
	}
     return;
   }
}

void SaveFunctionCoordinations(int fd)
{
  char buffer[100];

  strcpy(buffer, "CASE_SORT   = ");
  strcat(buffer, (distinct ? "TRUE" : "FALSE"));
  strcat(buffer, " # TRUE, FALSE\n");
  FPUTS(buffer, fd);
  strcpy(buffer, "NUMBER_SORT = ");
  strcat(buffer, (number ? "TRUE" : "FALSE"));
  strcat(buffer, " # TRUE, FALSE\n");
  FPUTS(buffer, fd);
  strcpy(buffer, "SORT_TARGET = ");
  strcat (buffer, (target == 0) ? "NODE" : (target == 1) ? "EXTENDER" : "WHOLE");
  strcat(buffer, " # NODE, EXTENDER, WHOLE\n");
  FPUTS(buffer, fd);
}
